#ifndef _QDP_TYPES
#define _QDP_TYPES

#ifndef __restrict__
#define __restrict__
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct QDP_prof_t {
  int count;
  double time;
  double comm_time;
  double math_time;
  double nsites;
  const char *func;
  const char *caller;
  int line;
  struct QDP_prof_t *next;
} QDP_prof;

typedef struct QDP_RandomState_struct QDP_RandomState;
typedef struct QDP_Int_struct QDP_Int;
typedef struct QDP_F_Real_struct QDP_F_Real;
typedef struct QDP_D_Real_struct QDP_D_Real;
typedef struct QDP_F_Complex_struct QDP_F_Complex;
typedef struct QDP_D_Complex_struct QDP_D_Complex;
typedef struct QDP_F2_ColorVector_struct QDP_F2_ColorVector;
typedef struct QDP_F3_ColorVector_struct QDP_F3_ColorVector;
typedef struct QDP_FN_ColorVector_struct QDP_FN_ColorVector;
typedef struct QDP_D2_ColorVector_struct QDP_D2_ColorVector;
typedef struct QDP_D3_ColorVector_struct QDP_D3_ColorVector;
typedef struct QDP_DN_ColorVector_struct QDP_DN_ColorVector;
typedef struct QDP_F2_HalfFermion_struct QDP_F2_HalfFermion;
typedef struct QDP_F3_HalfFermion_struct QDP_F3_HalfFermion;
typedef struct QDP_FN_HalfFermion_struct QDP_FN_HalfFermion;
typedef struct QDP_D2_HalfFermion_struct QDP_D2_HalfFermion;
typedef struct QDP_D3_HalfFermion_struct QDP_D3_HalfFermion;
typedef struct QDP_DN_HalfFermion_struct QDP_DN_HalfFermion;
typedef struct QDP_F2_DiracFermion_struct QDP_F2_DiracFermion;
typedef struct QDP_F3_DiracFermion_struct QDP_F3_DiracFermion;
typedef struct QDP_FN_DiracFermion_struct QDP_FN_DiracFermion;
typedef struct QDP_D2_DiracFermion_struct QDP_D2_DiracFermion;
typedef struct QDP_D3_DiracFermion_struct QDP_D3_DiracFermion;
typedef struct QDP_DN_DiracFermion_struct QDP_DN_DiracFermion;
typedef struct QDP_F2_ColorMatrix_struct QDP_F2_ColorMatrix;
typedef struct QDP_F3_ColorMatrix_struct QDP_F3_ColorMatrix;
typedef struct QDP_FN_ColorMatrix_struct QDP_FN_ColorMatrix;
typedef struct QDP_D2_ColorMatrix_struct QDP_D2_ColorMatrix;
typedef struct QDP_D3_ColorMatrix_struct QDP_D3_ColorMatrix;
typedef struct QDP_DN_ColorMatrix_struct QDP_DN_ColorMatrix;
typedef struct QDP_F2_DiracPropagator_struct QDP_F2_DiracPropagator;
typedef struct QDP_F3_DiracPropagator_struct QDP_F3_DiracPropagator;
typedef struct QDP_FN_DiracPropagator_struct QDP_FN_DiracPropagator;
typedef struct QDP_D2_DiracPropagator_struct QDP_D2_DiracPropagator;
typedef struct QDP_D3_DiracPropagator_struct QDP_D3_DiracPropagator;
typedef struct QDP_DN_DiracPropagator_struct QDP_DN_DiracPropagator;

#ifdef __cplusplus
}
#endif

#endif
